> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/cn/web-scraper-api/mu-biao/llm-yu-ai/gemini.md).

# Gemini

通过提交提示词提取 Gemini 响应，并以结构化 JSON、纯文本或 Markdown 接收解析数据。

该 `Gemini` 来源让你向 Google **Gemini** 并接收解析后的结构化响应，包括纯文本和 Markdown 答案。

## 请求示例

以下代码示例展示如何使用 [**Push-Pull**](/products/cn/web-scraper-api/integration-methods/push-pull.md).

{% tabs %}
{% tab title="cURL" %}

```bash
curl 'https://data.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "gemini",
        "prompt": "best supplements for better sleep",
        "parse": true,
        "geo_location": "United States",
        "callback_url": "https://your-server.com/oxylabs-callback"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    'source': 'gemini',
    'prompt': 'best supplements for better sleep',
    'parse': True,
    'geo_location': "United States",
    'callback_url': "https://your-server.com/oxylabs-callback"
}

# Get response.
response = requests.request(
    'POST',
    'https://data.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload,
)

# Print prettified response to stdout.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```js
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "gemini",
    prompt: "best supplements for better sleep",
    parse: true,
    geo_location: "United States",
    callback_url: "https://your-server.com/oxylabs-callback"
};

const options = {
    hostname: "data.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'gemini',
    'prompt' => 'best supplements for better sleep',
    'parse' => true,
    'geo_location' => "United States",
    'callback_url' => "https://your-server.com/oxylabs-callback"
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://data.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Go" %}

```go
package main

import (
"bytes"
"encoding/json"
"fmt"
"io/ioutil"
"net/http"
)

func main() {
const Username = "USERNAME"
const Password = "PASSWORD"

payload := map[string]interface{}{
"source":       "gemini",
"prompt":       "best supplements for better sleep",
"parse":        true,
"geo_location": "United States",
"callback_url": "https://your-server.com/oxylabs-callback",
}

jsonValue, _ := json.Marshal(payload)

client := &http.Client{}
request, _ := http.NewRequest("POST",
"https://data.oxylabs.io/v1/queries",
bytes.NewBuffer(jsonValue),
)

request.SetBasicAuth(Username, Password)
response, _ := client.Do(request)

responseText, _ := ioutil.ReadAll(response.Body)
fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new
            {
                source = "gemini",
                prompt = "best supplements for better sleep",
                parse = true,
                geo_location = "United States",
                callback_url = "https://your-server.com/oxylabs-callback"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://data.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "gemini");
        jsonObject.put("prompt", "best supplements for better sleep");
        jsonObject.put("parse", true);
        jsonObject.put("geo_location", "United States");
        jsonObject.put("callback_url", "https://your-server.com/oxylabs-callback");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://data.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "gemini",
    "prompt": "best supplements for better sleep",
    "parse": true,
    "geo_location": "United States",
    "callback_url": "https://your-server.com/oxylabs-callback"
}
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
**注意：** 所有 LLM 来源默认启用 JavaScript 渲染。你无需在请求负载中包含渲染参数。
{% endhint %}

使用以下方式提交任务 [**Push-Pull**](/products/cn/web-scraper-api/integration-methods/push-pull.md) 集成（包括 [批量查询](/products/cn/web-scraper-api/integration-methods/push-pull.md#batch-query)）方法会立即返回任务 ID，而不是结果。任务状态变为 `完成`后，再获取解析后的响应。请参见 [**集成方法**](/products/cn/web-scraper-api/integration-methods.md) 在 LLMs and AI 页面查看完整的提交与获取流程。

### 请求参数

抓取 Gemini 的基础设置和自定义选项。

<table><thead><tr><th width="222">参数</th><th width="350.3333333333333">描述</th><th>默认值</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark></td><td>设置抓取目标。使用 <code>Gemini</code>.</td><td>–</td></tr><tr><td><mark style="background-color:green;"><strong><code>prompt</code></strong></mark></td><td>要提交给 Gemini 的提示词或问题。最多 8,000 个字符。</td><td>–</td></tr><tr><td><code>callback_url</code></td><td><strong>推荐。</strong> 任务完成后我们发送通知的 URL。 <a href="https://developers.oxylabs.io/products/web-scraper-api/integration-methods/push-pull"><strong>更多信息</strong></a><strong>.</strong></td><td>–</td></tr><tr><td><code>parse</code></td><td>设置为 <code>true</code> 用于结构化 JSON 数据。</td><td><code>false</code></td></tr><tr><td><code>geo_location</code></td><td>指定请求路由来源国家。 <a href="/products/cn/web-scraper-api/features/localization.md"><strong>更多信息</strong></a>.</td><td>–</td></tr><tr><td><code>browser_instructions</code></td><td>在渲染 JavaScript 时可选的自定义浏览器指令。 <a href="/products/cn/web-scraper-api/features/js-rendering-and-browser-control.md#browser-instructions"><strong>更多信息</strong></a>.</td><td>–</td></tr></tbody></table>

&#x20;   \- 必填参数

## 结构化数据

一旦通过 Push-Pull 结果端点检索到任务，网页爬虫API 就能提取包含 Gemini 输出的 JSON 对象，为结果页面的各个元素提供结构化数据。

<details>

<summary><code>Gemini</code> 结构化输出</summary>

```json
{
  "results": [
    {
      "job_id": "7470031540181837825",
      "status_code": 200,
      "url": "https://gemini.google.com/app/ca6b069d5af5c809",
      "content": {
        "prompt": "best supplements for better sleep",
        "response_text": "If you are tossing and turning, you are definitely not alone. The supplement aisle is packed with options promising to help you drift off, but they generally fall into a few different categories based on how they actually affect your body. Here...",
        "markdown_text": "If you are tossing and turning, you are definitely not alone. The supplement aisle is packed with options promising to help you drift off, but they generally fall into a few different categories based on how they actually affect your body.\n\n Here...",
        "citations": [
          {
            "title": "Hartford HealthCare",
            "url": "https://hartfordhealthcare.org/about-us/news-press/news-detail?articleId=66180",
            "text": "Can These 3 Supplements Really Improve Your Sleep? | Hartford HealthCare | CT",
            "description": "- Valerian root. This herbal sleep option likely works by acting on GABA receptors in the brain, just like magnesium. \"But it's not without side effects,\" says ..."
          },
          {
            "title": "BBC Good Food",
            "url": "https://www.bbcgoodfood.com/review/best-sleep-supplements#:~:text=It's%20easy%20to%20get%20enough,a%20role%20in%20sleep%20regulation.",
            "text": "The best sleep supplements 2026 – tried and tested - BBC Good Food",
            "description": "It's easy to get enough through diet, but if you are looking to supplement, the NRV is around 300mg, and look for magnesium glycinate which has been shown to ..."
          },
          {
            "title": "PMC - NIH",
            "url": "https://pmc.ncbi.nlm.nih.gov/articles/PMC11082867/#:~:text=Melatonin%20is%20a%20hormone%20produced,promotes%20relaxation%20and%20reduced%20alertness.",
            "text": "Current Evidence on Common Dietary Supplements for Sleep Quality - PMC - NIH",
            "description": "Melatonin is a hormone produced by the pineal gland in the brain and plays a critical role in regulation of the sleep-wake cycle. The pineal gland begins ..."
          },
          ...
        ],
        "additional_results": {
          "sources_results": [
            {
              "title": "Best Sleep Supplements 2026: Evidence-Ranked Picks for Deeper",
              "url": "https://www.bettervitals.com/learn/best-sleep-supplement-stack-2026"
            },
            {
              "title": "10 of the Best Natural Sleep Aids in 2026 - Healthline",
              "url": "https://www.healthline.com/nutrition/sleep-aids"
            },
            ...
          ]
        },
        "parse_status_code": 12000
      }
    }
  ]
}
```

</details>

{% hint style="warning" %}
响应内容可能因查询是从 **桌面** 或 **移动** 设备。
{% endhint %}

### 输出数据字典

所有 LLM 目标都返回相同的顶层 `任务` 和 `results[]` 包装层。请参见 [LLMs and AI](/api-reference/dedicated-scrapers/llm-and-ai-scrapers.md) 获取完整的元数据参考。

下表显示 Gemini 专属的 `results[].content` 字段：

<table><thead><tr><th width="181.17578125">字段名</th><th width="427">描述</th><th>类型</th></tr></thead><tbody><tr><td><code>prompt</code></td><td>已提交的提示词。</td><td>字符串</td></tr><tr><td><code>raw_response</code></td><td>来自 Gemini 的原始流式响应，每个条目一行。</td><td>字符串数组</td></tr><tr><td><code>response_text</code></td><td>来自 Gemini 的纯文本响应。</td><td>字符串</td></tr><tr><td><code>markdown_text</code></td><td>完整的 Markdown 响应。</td><td>字符串</td></tr><tr><td><mark style="background-color:$warning;"><code>citations</code></mark></td><td>响应中引用的来源。每个对象包含 <code>title</code>, <code>url</code>, <code>text</code>，以及 <code>description</code>.</td><td>数组</td></tr><tr><td><mark style="background-color:$warning;"><code>additional_results</code></mark></td><td>附加搜索结果。 <code>sources_results</code> - Gemini 在回答时参考的网页列表（<code>title</code> 和 <code>url</code>).</td><td>对象</td></tr><tr><td><code>parse_status_code</code></td><td><code>12000</code> – 成功。否则，解析器未能提取部分或全部结构化字段。</td><td>整数</td></tr><tr><td><mark style="background-color:$warning;"><code>model</code></mark></td><td>用于生成响应的 AI 模型。</td><td>字符串</td></tr></tbody></table>

&#x20;    – 条件返回，仅当 content 出现在 LLM 的响应中时返回。


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.oxylabs.io/products/cn/web-scraper-api/mu-biao/llm-yu-ai/gemini.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
